#pragma semicolon 1
 
#include <sourcemod>
#include <sdktools>

#define PLUGIN_VERSION "1.0.1"

new Handle:gCvarBinos;
new Handle:gCvarBinosOfficers;
new Handle:hBinosTimer;

new g_fovOffset;
new g_weaponViewOffset;

new bool:g_useBinos[MAXPLAYERS+1];

public Plugin:myinfo =
{
	name = "Binoculars for DoDS",
	author = "Dog",
	description = "Binoculars for DoDS",
	version = PLUGIN_VERSION,
	url = "http://www.theville.org"
};

public OnPluginStart()
{
	CreateConVar("dod_binoculars_version", PLUGIN_VERSION, " DoD Binoculars Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	gCvarBinos = CreateConVar("dod_binoculars", "1", " Enable/Disable Binoculars", FCVAR_PLUGIN);
	gCvarBinosOfficers = CreateConVar("dod_binoculars_officers", "0", " Enable/Disable Binoculars", FCVAR_PLUGIN);
	
	RegConsoleCmd("use_binoculars", Command_Binoculars);
	
	HookEvent("player_spawn", SpawnEvent);
	HookEvent("player_death", DeathEvent);
	
	g_fovOffset = FindSendPropInfo("CBasePlayer", "m_iDefaultFOV");
	g_weaponViewOffset = FindSendPropInfo("CBasePlayer", "m_bDrawViewmodel");
}

public OnEventShutdown()
{
	UnhookEvent("player_spawn", SpawnEvent);
	UnhookEvent("player_death", DeathEvent);
}

public OnMapStart()
{
	AddFileToDownloadsTable("materials/models/props_misc/bino.vmt");
	AddFileToDownloadsTable("materials/models/props_misc/bino.vtf");	
	
	PrecacheModel("materials/models/props_misc/bino.vmt", true);
	
	if (hBinosTimer == INVALID_HANDLE)
		hBinosTimer = CreateTimer(1.0, Binos, 0, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
}

public SpawnEvent(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (GetConVarBool(gCvarBinos))
	{
		new client = GetClientOfUserId(GetEventInt(event, "userid"));
		SetEntData(client, g_fovOffset, 90, 1);
	}
}

public DeathEvent(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (GetConVarBool(gCvarBinos))
	{
		new client = GetClientOfUserId(GetEventInt(event, "userid"));
		g_useBinos[client] = false;
		
		EnableWeapons(client);
	}
}

public Action:Command_Binoculars(client, args)
{
	if (IsClientInGame(client) && IsPlayerAlive(client) && GetConVarBool(gCvarBinos))
	{
		if (GetConVarBool(gCvarBinosOfficers) && !(GetUserFlagBits(client) & ADMFLAG_CUSTOM1))
		{
			PrintToChat(client, "*Officers only allowed to use binoculars");
			return Plugin_Handled;
		}
		
		if (g_useBinos[client])
		{	
			g_useBinos[client] = false;
			ClientCommand(client, "r_screenoverlay 0");  
			SetEntData(client, g_fovOffset, 90, 1);
			SetEntData(client, g_weaponViewOffset, 1, 4);
			
			EnableWeapons(client);
		}
		else
		{
			g_useBinos[client] = true;
			ClientCommand(client, "r_screenoverlay models/props_misc/bino"); 
			SetEntData(client, g_fovOffset, 20, 1);
			SetEntData(client, g_weaponViewOffset, 0, 4);
			
			DisableWeapons(client);
		}
	}
	return Plugin_Handled;
}

public Action:Binos(Handle:timer, any:stuff)
{
	for (new i=1; i <= MaxClients; i++)
	{
		if (!IsClientInGame(i))
			continue;
			
		if (IsFakeClient(i))
			continue;
			
		if (IsClientObserver(i))
			continue;	
			
		if (!IsPlayerAlive(i))
			continue;	
		
		if (IsPlayerAlive(i))
		{
			if (g_useBinos[i])
				ClientCommand(i, "r_screenoverlay models/props_misc/bino");  
		}
	}
	return Plugin_Handled;
}

DisableWeapons(any:client)
{
	new weaponslot;
	for (new slot = 0; slot < 5; slot++)
	{
		weaponslot = GetPlayerWeaponSlot(client, slot);
		if(weaponslot != -1) 
		{
			SetEntPropFloat(weaponslot, Prop_Send, "m_flNextPrimaryAttack", GetGameTime() + 1200.0);
		}
	}
}

EnableWeapons(any:client)
{
	new weaponslot;
	for (new slot = 0; slot < 5; slot++)
	{
		weaponslot = GetPlayerWeaponSlot(client, slot);
		if(weaponslot != -1) 
		{
			SetEntPropFloat(weaponslot, Prop_Send, "m_flNextPrimaryAttack", GetGameTime());
		}
	}
}